#! /usr/bin/env python
# -*- coding: UTF-8 -*-
###
#
# This file is the legal property of Jean-Pierre Redonnet <redonnetbrouk@aol.com>
# Copyright (c) 2007 Jean-Pierre Redonnet
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###
import pygtk
pygtk.require('2.0')
import gtk,gobject
import sys,os,shutil,string,time
from time import localtime,strftime,strptime,mktime,clock

Prog_name='Burnimage'
version='0.10'
date_version='July 10 2008'


def message(title,message):
   dia = gtk.Dialog(title,
        None,  #the toplevel wgt of your app
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,  #binary flags or'ed together
        (gtk.STOCK_OK, gtk.RESPONSE_CLOSE))
   dia.vbox.pack_start(gtk.Label('\n'+message+'\n'))
   dia.show_all()
   result = dia.run()
   dia.destroy()
   return


def device_lister(w):
    global devicelist, dev
    
    #start scan cdrom available
    try: p=os.popen('cdrecord -scanbus').read()
    except:
       print 'cannot run cdrecord'
       return False
    if not 'CD-ROM' in p:
       print 'CD-ROM drive not found!'
       return False
    #erase the previous list and do a new one
    while len(devicelist)>0: del devicelist[0] #erase devicelist records
    while len(dev)>0: del dev[0] #erase dev records
    i=0
    for line in string.split(p,'\n'):
       if 'CD-ROM' in line:
          for device in string.split(line):break
          fin=line[string.find(line,"'")+1:]
          name=string.strip(fin[:string.find(fin,"'")])
          
          line=fin[string.find(fin,"'")+1:]
          fin=line[string.find(line,"'")+1:]
          name+=' '+string.strip(fin[:string.find(fin,"'")])

          i+=1
          iter = devicelist.append(None)
          devicelist.set(iter,0,i,1,name)
          dev.append(device)
    return True


def files_chooser(w):
   global pictures_path
   
   dialog = gtk.FileChooserDialog("Choose one image to burn",
                               None,
                               gtk.FILE_CHOOSER_ACTION_OPEN,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))
   dialog.set_default_response(gtk.RESPONSE_OK)
   dialog.set_current_folder(image_path)
   dialog.set_select_multiple(False)

   filter = gtk.FileFilter()
   filter.set_name("All files")
   filter.add_pattern("*")
   dialog.add_filter(filter)

   filter = gtk.FileFilter()
   filter.set_name("Image")
   filter.add_mime_type("image/iso")
   filter.add_pattern("*.iso")

   dialog.add_filter(filter)

   response = dialog.run()
   if response == gtk.RESPONSE_OK:
      #check if data is valid files
      filenames = dialog.get_filenames()
      for chain in filenames:
         chain=string.replace(chain,'%20',' ') #space char
         #put the file in the buffer
         textbuffer.set_text(chain+'\n')
         break #only the first one
   elif response == gtk.RESPONSE_CANCEL:
      print 'Closed, no files selected'
   dialog.destroy()
   return True

def motion_cb(wid, context, x, y, time):
    context.drag_status(gtk.gdk.ACTION_COPY, time)
    return True

def drop_cb(wid, context, x, y, time):
    if context.targets:
        w.drag_get_data(context, context.targets[0], time)
    context.finish(True, False, time)
    return True

#get data dropped and check if valid files or directories
def drag_data_received (window, context, x, y, data, info, time):
    #check if data is valid files
    for chain in string.split(data.data,'\r'):
        if 'file:' in chain:
            chain=string.replace(chain,'file:','')
            while '//' in chain: chain=string.replace(chain,'//','/')
            chain=string.replace(chain,'\n','')
            chain=string.replace(chain,'\r','')
            #chain=string.replace(chain,' ','%20') #space char
            chain=string.replace(chain,'%20',' ') #space char
            #put the file in the buffer
            textbuffer.set_text(chain+'\n')
            context.finish (True, False, time)
            break #only the first one
    return True


def cancel_valid(entry, data):
    valid = data
    valid.window.destroy()

#start burning
def valid(w):
    #get the text
    iterstart,iterend=textbuffer.get_bounds()
    text=textbuffer.get_text(iterstart,iterend)
    #supress empty lines
    while '\n\n' in text: text=string.replace(text,'\n\n','\n')
    if text=='': return False #there's nothing!
    #take the first file
    for file in string.split(text,'\n'):
        file=string.strip(file,'\n')
        file=string.strip(file,' ')
        if file<>'':
            #check
            if os.path.isfile(file):
                #get device, speed, option
                option=''
                device=' dev='+dev[combo1.get_active()]+' '
                iter=combo2.get_active_iter()
                model=combo2.get_model()
                speed=' speed='+model.get_value(iter, 1)+' '
                if check1.get_active(): option+=' -eject'
                if check2.get_active(): option+=' -multi'
                if check3.get_active(): option+=' -dummy'
                #command
                command='cdrecord'+option+speed+device+file
                print 'Command line: ',command
                #start burning with cdrecord
                try: pipe=os.popen(terminal_e+' -e "'+command+';read a;" &')
                #try: pipe=os.popen('cdrecord'+speed+device+file)
                except:
                   print 'cannot run cdrecord'
                   return False
                p=pipe.read()
                while p<>'':
                   message('cdrecord',p)
                   p=pipe.read()
                pipe.close()
            else:
                print file+' is not a file!'
    return True
   
#clear the text window
def erase(w):
    textbuffer.set_text('')
    return

def help(w):
    dia = gtk.Dialog('Help',
        None,  #the toplevel wgt of your app
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,  #binary flags or'ed together
        ('_More info', 77,gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
    dia.vbox.pack_start(gtk.Label('\nJP Redonnet\nVers. '+version+' - '+date_version+'\n'+Prog_name+' burn iso image\nGUI for cdrecord\n\n'+
                                  '1 - Drop the iso file in the drop area.\n'+
                                  '2 - Choose the device and the speed.\n'+
                                  '3 - Check multissession if you plan to add files.\n'+
                                  '4 - Check simulation to turn off the laser.\n'+
                                  '5 - Click burn to start!\n'+
                                  'NB: Run from xterm for debug msg.\n'+
                                  'click cdrom to update the devices list.\n'))
    dia.show_all()
    result = dia.run()
    dia.destroy()
    if result == 77:
        fp=os.popen(terminal_e+' -e man burnimage &')
        gtk.RESPONSE_CLOSE
    return

#### program starts here ! ####
home_user_path=os.path.expanduser('~')
burnimage_path=home_user_path+'/burnimage/'
# if the full path to data does'nt exist create it
if not os.path.isdir(burnimage_path):
    print burnimage_path,"doesn't exist!"
    try: os.mkdir(burnimage_path) #create the path
    except:
        message("Error","impossible to create "+burnimage_path)
        exit()
    else:
        print burnimage_path,"has been created"
if not os.path.isfile(burnimage_path+'burnimage.cfg'):
    print burnimage_path+"burnimage.cfg doesn't exist!"
    try: f=open(burnimage_path+'burnimage.cfg','w')
    except:
        message('Error','impossible to create '+burnimage_path+'burnimage.cfg')
        exit()
    f.write('#configuration file of burnimage\n')
    f.write('vn:1\n')
    f.write('ls:speed=2\n')
    f.write('ms:speed=8\n')
    f.write('hs:speed=16\n')
    f.write('vs:speed=32\n')
    f.write('dv:dev=3,0,0\n')
    f.write('te:xterm\n')
    f.write('ip:\n')
    f.write('#end of file\n')
    f.close()
#read config file
version_n='0'
pictures_path=''
try: f=open(burnimage_path+'burnimage.cfg','r')
except:
    message('Error','impossible to open '+burnimage_path+'burnimage.cfg')
    exit()
for line in f:
    if line[:3]=='vn:': version_n=string.strip(line[3:-1])
    if line[:3]=='ls:': low_speed=string.strip(line[3:-1])
    if line[:3]=='ms:': medium_speed=string.strip(line[3:-1])
    if line[:3]=='hs:': high_speed=string.strip(line[3:-1])
    if line[:3]=='vs:': very_speed=string.strip(line[3:-1])
    if line[:3]=='dv:': device=' '+string.strip(line[3:-1])+' '
    if line[:3]=='te:': terminal_e=string.strip(line[3:-1])
    if line[:3]=='ip:': image_path=string.strip(line[3:-1])
f.close()
if version_n<>'1':
    message('Error','Config file is not compatible')
    exit
if pictures_path=='': pictures_path=home_user_path

#start scan cdrom available
try: p=os.popen('cdrecord -scanbus').read()
except:
   print 'cannot run cdrecord'
   exit
if not 'CD-ROM' in p:
   print 'CD-ROM drive not found!'
   exit

dev=[]
devicelist = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING)
i=0
for line in string.split(p,'\n'):
   if 'CD-ROM' in line:
      for device in string.split(line):break
      fin=line[string.find(line,"'")+1:]
      name=string.strip(fin[:string.find(fin,"'")])
          
      line=fin[string.find(fin,"'")+1:]
      fin=line[string.find(line,"'")+1:]
      name+=' '+string.strip(fin[:string.find(fin,"'")])

      i+=1
      iter = devicelist.append(None)
      devicelist.set(iter,0,i,1,name)
      dev.append(device)

speedlist = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING)
for i in range(2,48,2):
   iter = speedlist.append(None)
   speedlist.set(iter,0,i,1,repr(i))

#the main window
w = gtk.Window()
w.set_title(Prog_name+' '+version)
w.set_default_size(280, 300)
w.drag_dest_set(0, [], 0)
h0box = gtk.HBox(False, 0)
h1box = gtk.HBox(False, 0)
vbox = gtk.VBox(False, 0)
hbox = gtk.HBox(False, 0)
w.add(vbox)
#scrollable text window
sw = gtk.ScrolledWindow()    
sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
textview = gtk.TextView()
textbuffer = textview.get_buffer()
sw.add(textview)
sw.show()
textview.show()
vbox.pack_start(sw)
textbuffer.set_text('')
#label
label = gtk.Label()
frame = gtk.Frame('Drop here')
label.set_line_wrap(True)
label.set_text('\n\n')
frame.add(label)
vbox.pack_start(frame, False, False, 0)
#button
button0 = gtk.Button("_Folder",gtk.STOCK_OPEN)
h0box.pack_start(button0, False, False, 0)
#label
label0 = gtk.Label()
label0.set_line_wrap(True)
label0.set_text('<Choose or ^drop one *.iso file')
h0box.pack_start(label0, False, False, 0)
vbox.add(h0box)
#button
frame0 = gtk.Frame('Update')
button1 = gtk.Button('_CD')
frame0.add(button1)
h1box.pack_start(frame0, False, False, 0)
# Combo
combo1 = gtk.ComboBox(devicelist)
renderer1 = gtk.CellRendererText()
combo1.pack_start(renderer1, True)
combo1.add_attribute(renderer1, 'text', 1)
combo1.set_active(0)
frame1 = gtk.Frame('Burner')
frame1.add(combo1)
h1box.pack_start(frame1, False, False, 0)
combo2 = gtk.ComboBox(speedlist)
renderer2 = gtk.CellRendererText()
combo2.pack_start(renderer2, True)
combo2.add_attribute(renderer2, 'text', 1)
combo2.set_active(0)
frame2 = gtk.Frame('Speed')
frame2.add(combo2)
h1box.pack_start(frame2, False, False, 0)
vbox.add(h1box)
#checkbox
check1 = gtk.CheckButton("_Eject at the end")
vbox.pack_start(check1, False, False, 0)
check1.set_active(True)
check2 = gtk.CheckButton("_Multisession")
vbox.pack_start(check2, False, False, 0)
check2.set_active(False)
check3 = gtk.CheckButton("_Simulation (do not burn)")
vbox.pack_start(check3, False, False, 0)
check3.set_active(False)
#buttons
button2 = gtk.Button("_Burn",gtk.STOCK_MEDIA_RECORD)
hbox.pack_start(button2, False, False, 0)
button3 = gtk.Button("_Clear",gtk.STOCK_CLEAR)
hbox.pack_start(button3, False, False, 0)
button4 = gtk.Button("_Help",gtk.STOCK_HELP)
hbox.pack_start(button4, False, False, 0)
button5 = gtk.Button("_Close",gtk.STOCK_CLOSE)
hbox.pack_start(button5, False, False, 0)
vbox.add(hbox)
#connections
button0.connect("clicked",files_chooser)
button1.connect("clicked",device_lister)
button2.connect("clicked",valid)
button3.connect("clicked",erase)
button4.connect("clicked",help)
button5.connect("clicked",lambda w: gtk.main_quit())

w.connect('drag_motion', motion_cb)
w.connect('drag_drop', drop_cb)
w.connect ('drag_data_received', drag_data_received)
w.connect('destroy', lambda w: gtk.main_quit())

w.show_all()

gtk.main()

#simple gui frontend for cdrecord
#prebuilt items: http://library.gnome.org/devel/gtk/stable/gtk-Stock-Items.html
#Ver 0.10 June 10th 2008

